package net.mcreator.ardaivona.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.ardaivona.world.inventory.FaunapageMenu;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class FaunapageScreen extends AbstractContainerScreen<FaunapageMenu> {
	private final static HashMap<String, Object> guistate = FaunapageMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_fernodus_spawn_egg;
	ImageButton imagebutton_seivanosk_sapling;

	public FaunapageScreen(FaunapageMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 146;
		this.imageHeight = 160;
	}

	private static final ResourceLocation texture = new ResourceLocation("ardaivona:textures/screens/faunapage.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(new ResourceLocation("ardaivona:textures/screens/book.png"), this.leftPos + -19, this.topPos + -9, 0, 0, 256, 256, 256, 256);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.ardaivona.faunapage.label_fauna"), 17, 60, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.ardaivona.faunapage.label_flora_and_fungi"), 20, 113, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_fernodus_spawn_egg = new ImageButton(this.leftPos + 30, this.topPos + 35, 16, 16, 0, 0, 16, new ResourceLocation("ardaivona:textures/screens/atlas/imagebutton_fernodus_spawn_egg.png"), 16, 32, e -> {
		});
		guistate.put("button:imagebutton_fernodus_spawn_egg", imagebutton_fernodus_spawn_egg);
		this.addRenderableWidget(imagebutton_fernodus_spawn_egg);
		imagebutton_seivanosk_sapling = new ImageButton(this.leftPos + 31, this.topPos + 92, 16, 16, 0, 0, 16, new ResourceLocation("ardaivona:textures/screens/atlas/imagebutton_seivanosk_sapling.png"), 16, 32, e -> {
		});
		guistate.put("button:imagebutton_seivanosk_sapling", imagebutton_seivanosk_sapling);
		this.addRenderableWidget(imagebutton_seivanosk_sapling);
	}
}
