package net.mcreator.ardaivona.entity.model;

import software.bernie.geckolib.model.data.EntityModelData;
import software.bernie.geckolib.model.GeoModel;
import software.bernie.geckolib.core.animation.AnimationState;
import software.bernie.geckolib.core.animatable.model.CoreGeoBone;
import software.bernie.geckolib.constant.DataTickets;

import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.ardaivona.entity.FlowerheadEntity;

public class FlowerheadModel extends GeoModel<FlowerheadEntity> {
	@Override
	public ResourceLocation getAnimationResource(FlowerheadEntity entity) {
		return new ResourceLocation("ardaivona", "animations/flowerhead.animation.json");
	}

	@Override
	public ResourceLocation getModelResource(FlowerheadEntity entity) {
		return new ResourceLocation("ardaivona", "geo/flowerhead.geo.json");
	}

	@Override
	public ResourceLocation getTextureResource(FlowerheadEntity entity) {
		return new ResourceLocation("ardaivona", "textures/entities/" + entity.getTexture() + ".png");
	}

	@Override
	public void setCustomAnimations(FlowerheadEntity animatable, long instanceId, AnimationState animationState) {
		CoreGeoBone head = getAnimationProcessor().getBone("Head");
		if (head != null) {
			EntityModelData entityData = (EntityModelData) animationState.getData(DataTickets.ENTITY_MODEL_DATA);
			head.setRotX(entityData.headPitch() * Mth.DEG_TO_RAD);
			head.setRotY(entityData.netHeadYaw() * Mth.DEG_TO_RAD);
		}

	}
}
