
package net.mcreator.ardaivona.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.ardaivona.init.ArdaivonaModItems;
import net.mcreator.ardaivona.init.ArdaivonaModFluids;
import net.mcreator.ardaivona.init.ArdaivonaModFluidTypes;
import net.mcreator.ardaivona.init.ArdaivonaModBlocks;

public abstract class PitcherAcidFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> ArdaivonaModFluidTypes.PITCHER_ACID_TYPE.get(), () -> ArdaivonaModFluids.PITCHER_ACID.get(), () -> ArdaivonaModFluids.FLOWING_PITCHER_ACID.get())
			.explosionResistance(100f).tickRate(7).bucket(() -> ArdaivonaModItems.PITCHER_ACID_BUCKET.get()).block(() -> (LiquidBlock) ArdaivonaModBlocks.PITCHER_ACID.get());

	private PitcherAcidFluid() {
		super(PROPERTIES);
	}

	public static class Source extends PitcherAcidFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends PitcherAcidFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
